searchNodes=[{"doc":"Contrak helps to validate data with given schema: task_schema = %{ title : [ type : :string , required : true , length : [ min : 20 ] ] , description : :string , tag : [ type : { :array , :string } , default : [ ] ] point : [ type : :integer , number : [ min : 0 ] ] , due_date : [ type : NaiveDateTime , default : &amp; seven_day_from_now / 0 ] , assignee : [ type : { :array , User } , required : true ] , attachments : [ type : { :array , %{ name : [ type : :string , required : true ] , url : :string } } ] } case Contrak . validate ( data , task_schema ) do { :ok , valid_data } -&gt; # do your logic { :error , errors } -&gt; IO . inspect ( errors ) end Contrak also do: Support nested type Clean not allowed fields NOTES: Contract only validate data, not cast data Schema definition Contrak provide a simple schema definition: &lt;field_name&gt;: [type: &lt;type&gt;, required: &lt;true|false&gt;, default: &lt;value|function&gt;, [...validation]] Shorthand form if you only check for type: &lt;field_name&gt;: &lt;type&gt; type is all types supported by Valdi.validate_type , and extended to support nested type. Nested type is just another schema. default : could be a function func/0 or a value. Default function is invoked for every time validate is called. If not set, default value is nil required : if set to true , validate if a field does exist and not nil . Default is false . validations : all validation support by Valdi , if value is nil then all validation is skip For more details, please check document for Contrak.Schema Validations Contrak uses Valdi to validate data. So you can use all validation from Valdi . This is list of available validation for current version of Valdi: Validate type Validate required Validate in | not_in enum Valiate length for string , enumerable Validate number Validate string against regex pattern Custom validation function Please check Valdi document for more details Another example @update_user_contract %{ user : [ type : User , required : true ] , attributes : [ type : %{ email : [ type : :string ] , status : [ type : :string , in : ~w(active in_active) ] age : [ type : :integer , number : [ min : 10 , max : 80 ] ] , } , required : true ] } def update_user ( contract ) do with { :ok , validated_data } do validated_data . user |&gt; Ecto.Changeset . change ( validated_data . attributes ) |&gt; Repo . update else { :error , errors } -&gt; IO . inspect ( errors ) end end","ref":"Contrak.html","title":"Contrak","type":"module"},{"doc":"Validate data against given schema","ref":"Contrak.html#validate/2","title":"Contrak.validate/2","type":"function"},{"doc":"This is only a specification to define a schema to use with Contract.validate Schema is just a map or keyword list that follow some simple conventions. Map's key is the field name and the value is a keyword list of field specifications. Example %{ name : [ type : :string , format : ~r/\d{4}/ ] , age : [ type : :integer , number : [ min : 15 , max : 50 ] ] . skill : [ type : { :array , :string } , length : [ min : 1 , max : 10 ] ] } If you only specify type of data, you can write it shorthand style like this %{ name : :string , age : :integer , skill : { :array , :string } } I. Field type Built-in types A type could be any of built-in supported types: boolean string | binary integer float number (integer or float) date time datetime | utc_datetime : date time with time zone naive_datetime : date time without time zone map keyword {array, type} array of built-in type, all item must be the same type Other types Custom type may be supported depends on module. Nested types Nested types could be a another schema or list of schema %{ user : [ type : %{ name : [ type : :string ] } ] } Or list of schema %{ users : [ type : { :array , %{ name : [ type : :string ] } } ] } II. Field casting and default value These specifications is used for casting data with Contrak.Params.cast 1. Default value Is used when the given field is missing or nil. Default could be a value %{ status : [ type : :string , default : &quot;active&quot; ] } Or a function/0 , this function will be invoke each time data is casted %{ published_at : [ type : :datetime , default : &amp; DateTime . utc_now / 0 ] } 2. Custom cast function You can provide a function to cast field value instead of using default casting function by using cast_func: &lt;function/1&gt; %{ published_at : [ type : :datetime , cast_func : &amp; DateTime . from_iso8601 / 1 ] } III. Field validation These validation are supported by Contrak.Validator 1. Type validation Type specification above could be used for validating or casting data. 2. Numeric validation Support validating number value. These are list of supported validations: equal_to greater_than_or_equal_to | min greater_than less_than less_than_or_equal_to | max Define validation: number: [&lt;name&gt;: &lt;value&gt;, ...] Example %{ age : [ type : :integer , number : [ min : 1 , max : 100 ] ] } 3. Length validation Validate length of supported types include string , array , map , tuple , keyword . Length condions are the same with Numeric validation Define validation: length: [&lt;name&gt;: &lt;value&gt;, ...] Example %{ skills : [ type : { :array , :string } , length : [ min : 0 , max : 5 ] ] } 4. Format validation Check if a string match a given pattern. Define validation: format: &lt;Regex&gt; Example %{ year : [ type : :string , format : ~r/year: \d{4}/ ] } 5. Inclusion and exclusion validation Check if value is included or not included in given enumerable ( array , map , or keyword ) Define validation: in: &lt;enumerable&gt; or not_in: &lt;enumerable&gt; Example %{ status : [ type : :string , in : [ &quot;active&quot; , &quot;inactive&quot; ] ] , selected_option : [ type : :integer , not_in : [ 2 , 3 ] ] } 6. Custom validation function You can provide a function to validate the value. Define validation: func: &lt;function&gt; Function must be follow this signature @spec func ( value :: any ( ) ) :: :ok | { :error , message :: String . t ( ) }","ref":"Contrak.Schema.html","title":"Contrak.Schema","type":"module"},{"doc":"Expand short-hand type syntax to full syntax field : :string -&gt; field : [ type : :string ] field : { :array , :string } -&gt; field : [ type : { :array , :string } ] field : % { #embedded} -&gt; field: [type: %{#embedded}]","ref":"Contrak.Schema.html#expand/1","title":"Contrak.Schema.expand/1","type":"function"},{"doc":"Contrak Schema and contract validation library for Elixir This library is best suited for validating compicated params contract/schema passing to your function. For example when you build a client library that call 3rd API and you want to make sure all parameters are valid before processing. If you want to cast external data to your internal schema, take a look at Tarams","ref":"readme.html","title":"Contrak","type":"extras"},{"doc":"Adding contrak to your list of dependencies in mix.exs : def deps do [ { :contrak , &quot;~&gt; 0.1.1&quot; } ] end Documentation here https://hexdocs.pm/contrak .","ref":"readme.html#installation","title":"Contrak - Installation","type":"extras"},{"doc":"Contrak helps to validate data with given schema: task_schema = %{ title : [ type : :string , required : true , length : [ min : 20 ] ] , description : :string , tag : [ type : { :array , :string } , default : [ ] ] point : [ type : :integer , number : [ min : 0 ] ] , due_date : [ type : NaiveDateTime , default : &amp; seven_day_from_now / 0 ] , assignee : [ type : { :array , User } , required : true ] , attachments : [ type : %{ name : [ type : :string , required : true ] , url : :string } ] } case Contrak . validate ( data , task_schema ) do { :ok , valid_data } -&gt; # do your logic { :error , errors } -&gt; IO . inspect ( errors ) end Contrak also do: Support nested type Clean not allowed fields NOTES: Contract only validate data, not cast data","ref":"readme.html#usage","title":"Contrak - Usage","type":"extras"},{"doc":"Contrak provide a simple schema definition: &lt;field_name&gt;: [type: &lt;type&gt;, required: &lt;true|false&gt;, default: &lt;value|function&gt;, [...validation]] %{ product_name : [ type : :string , required : true , length : [ min : 20 ] ] , sku : [ type : :string , required : true ] , selling_price : [ type : :integer , required : true , number : [ min : 0 ] ] state : [ type : :string , default : &quot;draft&quot; ] } Shorthand form if you only check for type: &lt;field_name&gt;: &lt;type&gt; %{ product_name : :string , sku : :string , price : :integer } type is all types supported by Valdi.validate_type , and extended to support nested type. Nested type is just another schema. default : could be a function func/0 or a value. Default function is invoked for every time validate is called. If not set, default value is nil required : if set to true , validate if a field does exist and not nil . Default is false . validations : all validation support by Valdi , if value is nil then all validation is skip For more details, please check document for Contrak.Schema","ref":"readme.html#schema-definition","title":"Contrak - Schema definition","type":"extras"},{"doc":"Contrak uses Valdi to validate data. So you can use all validation from Valdi . This is list of available validation for current version of Valdi: Validate type Validate required Validate in | not_in enum Valiate length for string , enumerable Validate number Validate string against regex pattern Custom validation function Please check Valdi document for more details","ref":"readme.html#validations","title":"Contrak - Validations","type":"extras"}]